@echo off

:: Introduction is located after local function definitions.
if "%~1"=="" goto :_#intro
if "%~1"=="init" goto :_#init

:: Process calls from user macros.
setlocal enableDelayedExpansion
set "_$ed=" & set "rvar=" & set "rval=ERROR"
call %* 2>NUL || if defined _$show_errors %_@showErrorMes% "!errorlevel!" & set "_$show_results="
if not defined rvar if defined rval if defined _$show_results echo !rval!
endlocal & if not "%rvar%"=="" set "%rvar%=%rval%"
exit /b %errorlevel%

::===================================================================
::---------------- BEGIN LOCAL FUNCTION DEFINITIONS -----------------
:: These are only for internal usage and should never be called directly.

:_#addi
  set "aendA=%1" & set "aendB=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalInt% !aendA: =@! 9 T T snAendA fAendA bAendA
  %_@evalInt% !aendB: =@! 9 T T snAendB fAendB bAendB
  %_@add% "%snAendA%" "%snAendB%" "%fAendA%" "%bAendA%" "%fAendB%" "%bAendB%" snSum fSum bSum
  %_@trimLeadZeros% "%fSum%%bSum%" sum
  %_@finIntAS% "%snSum%" "%sum%" rval
  exit /b 0

:_#subi
  set "mend=%1" & set "send=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalInt% !mend: =@! 9 T T snMend fMend bMend
  %_@evalInt% !send: =@! 9 T T snSend fSend bSend
  %_@negateSign% snSend
  %_@add% "%snMend%" "%snSend%" "%fMend%" "%bMend%" "%fSend%" "%bSend%" snDiff fDiff bDiff
  %_@trimLeadZeros% "%fDiff%%bDiff%" diff
  %_@finIntAS% "%snDiff%" "%diff%" rval
  exit /b 0

:_#multi
  set "mand=%1" & set "mltr=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalInt% !mand: =@! 8 T F snMand fMand bMand
  %_@evalInt% !mltr: =@! 8 T F snMltr fMltr bMltr
  %_@intLen% "%fMand%%bMand%" lnMand
  %_@intLen% "%fMltr%%bMltr%" lnMltr
  %_@multiply% "%fMand%" "%bMand%" "%fMltr%" "%bMltr%" "%lnMand%" "%lnMltr%" prod
  %_@trimLeadZeros% "%prod%" tProd
  %_@finIntMD% "%snMand%" "%snMltr%" "%tProd%" rval
  exit /b 0

:_#divi
  set "dend=%1" & set "dsor=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalInt% !dend: =@! "%_$MAX_WD%" F F snDend wDend
  %_@evalInt% !dsor: =@! 8 F F snDsor wDsor
  %_@evalIntDsor% "%wDsor%"
  %_@intLen% "%wDend%" lnDend
  %_@divideInts% "%wDend%" "%wDsor%" "%lnDend%" quo
  %_@finIntMD% "%snDend%" "%snDsor%" "%quo%" rval
  exit /b 0

:_#addf
  set "aendA=%1" & set "aendB=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalFlt% !aendA: =@! 9 snAendA fAendA bAendA
  %_@evalFlt% !aendB: =@! 9 snAendB fAendB bAendB 
  %_@roundFlt% "%fAendA%" "%bAendA%" 8 rfAendA rbAendA
  %_@roundFlt% "%fAendB%" "%bAendB%" 8 rfAendB rbAendB
  %_@fmtDeci% rbAendA
  %_@fmtDeci% rbAendB
  %_@add% "%snAendA%" "%snAendB%" "%rfAendA%" "%rbAendA%" "%rfAendB%" "%rbAendB%" snSum fSum bSum
  %_@roundFlt% "%fSum%" "%bSum%" "%_$rd%" rfSum rbSum
  %_@trimDecimals% "%rbSum%" "%_$dp%" rtbSum
  %_@finFltAS% "%snSum%" "%rfSum%" "%rtbSum%" "%_$dm%" rval
  exit /b 0

:_#subf
  set "mend=%1" & set "send=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalFlt% !mend: =@! 9 snMend fMend bMend
  %_@evalFlt% !send: =@! 9 snSend fSend bSend
  %_@roundFlt% "%fMend%" "%bMend%" 8 rfMend rbMend
  %_@roundFlt% "%fSend%" "%bSend%" 8 rfSend rbSend
  %_@fmtDeci% rbMend
  %_@fmtDeci% rbSend
  %_@negateSign% snSend
  %_@add% "%snMend%" "%snSend%" "%rfMend%" "%rbMend%" "%rfSend%" "%rbSend%" snDiff fDiff bDiff
  %_@roundFlt% "%fDiff%" "%bDiff%" "%_$rd%" rfDiff rbDiff
  %_@trimDecimals% "%rbDiff%" "%_$dp%" rtbDiff
  %_@finFltAS% "%snDiff%" "%rfDiff%" "%rtbDiff%" "%_$dm%" rval
  exit /b 0 

:_#multf
  set "mand=%1" & set "mltr=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalFlt% !mand: =@! 8 snMand fMand bMand
  %_@evalFlt% !mltr: =@! 8 snMltr fMltr bMltr
  %_@roundFlt% "%fMand%" "%bMand%" 8 rfMand rbMand
  %_@roundFlt% "%fMltr%" "%bMltr%" 8 rfMltr rbMltr
  %_@fltLen% "%fMand%%bMand%" lnMand
  %_@fltLen% "%fMltr%%bMltr%" lnMltr
  %_@multiply% "%rfMand%" "%rbMand%" "%rfMltr%" "%rbMltr%" "%lnMand%" "%lnMltr%" fProd bProd
  %_@trimLeadZeros% "%fProd%" tfProd
  %_@roundFlt% "%tfProd%" "%bProd%" "%_$rd%" rtfProd rbProd
  %_@trimDecimals% "%rbProd%" "%_$dp%" rtbProd
  %_@finFltMD% "%snMand%" "%snMltr%" "%rtfProd%" "%rtbProd%" "%_$dm%" rval
  exit /b 0 

:_#divf
  set "dend=%1" & set "dsor=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalFlt% !dend: =@! 24 snDend fDend bDend
  %_@evalFlt% !dsor: =@! 8 snDsor fDsor bDsor
  %_@roundFlt% "%fDend%" "%bDend%" 8 rfDend rbDend
  %_@roundFlt% "%fDsor%" "%bDsor%" 8 rfDsor rbDsor
  %_@evalFltDsor% "%rfDsor%" "%rbDsor%"
  %_@fltLen% "%rfDend%" lnrfDend
  %_@fltLen% "%rbDend%" lnrbDend
  %_@divideFlts% "%rfDend%" "%rbDend%" "%rfDsor%" "%rbDsor%" "%lnrfDend%" "%lnrbDend%" "%_$dp%" fQuo bQuo
  %_@trimLeadZeros% "%fQuo%" tfQuo
  %_@roundFlt% "%tfQuo%" "%bQuo%" "%_$rd%" rtfQuo rbQuo
  %_@trimDecimals% "%rbQuo%" "%_$dp%" rtbQuo
  %_@finFltMD% "%snDend%" "%snDsor%" "%rtfQuo%" "%rtbQuo%" "%_$dm%" rval
  exit /b 0

:_#modi
  set "dend=%1" & set "dsor=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalInt% !dend: =@! 8 T F snDend fDend bDend
  %_@evalInt% !dsor: =@! 8 F F snDsor wDsor
  %_@evalIntDsor% "%wDsor%"
  %_@fltLen% "%fDend%%bDend%" lnDend
  %_@divideInts% "%fDend%%bDend%" "%wDsor%" "%lnDend%" quo
  %_@splitUInt% %quo% F fMand bMand
  %_@intLen% "%fMand%%bMand%" lnMand
  %_@intLen% "%wDsor%" lnDsor
  %_@multiply% "%fMand%" "%bMand%" "0" "%wDsor%" "%lnMand%" "%lnDsor%" prod
  %_@trimLeadZeros% "%prod%" tProd
  %_@fmtInt% bDend
  %_@splitUInt% %tProd% T fSend bSend
  %_@add% "" "-" "%fDend%" "%bDend%" "%fSend%" "%bSend%" snDiff fDiff bDiff
  %_@trimLeadZeros% "%fDiff%%bDiff%" diff
  %_@finIntAS% "%snDend%" "%diff%" rval
  exit /b 0

:_#modf
  set "dend=%1" & set "dsor=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalFlt% !dend: =@! 4 snDend fDend bDend
  %_@evalFlt% !dsor: =@! 8 snDsor fDsor bDsor
  %_@roundFlt% "%fDend%" "%bDend%" 8 rfDend rbDend
  %_@roundFlt% "%fDsor%" "%bDsor%" 5 rfDsor rbDsor
  %_@evalFltDsor% "%rfDsor%" "%rbDsor%"
  %_@fltLen% "%rfDend%" lnrfDend
  %_@fltLen% "%rbDend%" lnrbDend
  %_@divideFlts% "%rfDend%" "%rbDend%" "%rfDsor%" "%rbDsor%" "%lnrfDend%" "%lnrbDend%" "%_$dp%" fQuo bQuo
  %_@trimLeadZeros% "%fQuo%" tfQuo
  %_@fltLen% "%tfQuo%0" lnMand
  %_@fltLen% "%rfDsor%%rbDsor%" lnDsor
  %_@multiply% "%tfQuo%" "0" "%rfDsor%" "%rbDsor%" "%lnMand%" "%lnDsor%" fProd bProd
  %_@trimLeadZeros% "%fProd%" tfProd
  %_@trimDecimals% "%bProd%" "%_$dp%" tbProd
  %_@fmtDeci% rbDend
  %_@fmtDeci% tbProd
  %_@add% "" "-" "%rfDend%" "%rbDend%" "%tfProd%" "%tbProd%" snDiff fDiff bDiff
  %_@roundFlt% "%fDiff%" "%bDiff%" "%_$rd%" rfDiff rbDiff
  %_@trimDecimals% "%rbDiff%" "%_$dp%" rtbDiff
  %_@finFltAS% "%snDend%" "%rfDiff%" "%rtbDiff%" "%_$dm%" rval
  exit /b 0

:_#rand
  set "var=%1"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %2
  %_@genRand% mand
  %_@intLen% "%mand%" lnMand
  %_@intLen% "10000000" lnMltr
  %_@multiply% "0" "%mand%" "0" "10000000" "%lnMand%" "%lnMltr%" prod
  %_@trimLeadZeros% "%prod%" tProd
  %_@intLen% "%tProd%" lntProd
  %_@divideInts% "%tProd%" "90000000" "%lntProd%" rval
  exit /b 0

:_#randr
  set "min=%1" & set "max=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalInt% !min: =@! 7 F F snMin wMin
  %_@evalInt% !max: =@! 7 F F snMax wMax
  %_@compInts% "%snMin%" "%snMax%" "%wMin%" "%wMax%" comp
  %_@evalRange% %comp%
  %_@genRandRange% "%snMin%" "%snMax%" "%wMin%" "%wMax%" finSign finMin mand mltr
  %_@intLen% "%mand%" lnMand
  %_@intLen% "%mltr%" lnMltr
  %_@multiply% "0" "%mand%" "0" "%mltr%" "%lnMand%" "%lnMltr%" prod
  %_@trimLeadZeros% "%prod%" tProd
  %_@intLen% "%tProd%" lntProd
  %_@divideInts% "%tProd%" "90000000" "%lntProd%" quo
  %_@finRand% "%finSign%" "%quo%" "%finMin%" rval
  exit /b 0

:_#trimf
  set "num=%1" & set "places=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalFlt% !num: =@! "%_$MAX_WD%" snNum wNum dNum
  %_@evalValue% !places: =@! "%_$MAX_RP%"
  %_@trimDecimals% "%dNum%" %places% tdNum
  %_@finFltAS% "%snNum%" "%wNum%" "%tdNum%" "%_$dm%" rval
  exit /b 0

:_#roundf
  set "num=%1" & set "pos=%2" & set "var=%3"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %4
  %_@evalFlt% !num: =@! "%_$MAX_WD%" snNum wNum dNum
  %_@evalValue% !pos: =@! "%_$MAX_RP%"
  %_@roundFlt% "%wNum%" "%dNum%" %pos% rwNum rdNum
  %_@trimDecimals% "%rdNum%" %pos% rtdNum
  %_@finFltAS% "%snNum%" "%rwNum%" "%rtdNum%" "%_$dm%" rval
  exit /b 0

:_#compi
  set "numA=%1" & set "op=%2" & set "numB=%3" & set "var=%4"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %5
  %_@evalInt% !numA: =@! "%_$MAX_WD%" F F snNumA wNumA
  %_@evalInt% !numB: =@! "%_$MAX_WD%" F F snNumB wNumB
  %_@compInts% "%snNumA%" "%snNumB%" "%wNumA%" "%wNumB%" comp
  %_@evalOp% !op: =@! "%comp%" rval
  exit /b 0

:_#compf
  set "numA=%1" & set "op=%2" & set "numB=%3" & set "var=%4"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %5
  %_@evalFlt% !numA: =@! "%_$MAX_WD%" snNumA wNumA dNumA
  %_@evalFlt% !numB: =@! "%_$MAX_WD%" snNumB wNumB dNumB
  %_@compFlts% "%snNumA%" "%snNumB%" "%wNumA%" "%dNumA%" "%wNumB%" "%dNumB%" comp
  %_@evalOp% !op: =@! "%comp%" rval
  exit /b 0

:_#rangei
   set "num=%1" & set "min=%2" & set "max=%3" & set "var=%4"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %5
  %_@evalInt% !num: =@! "%_$MAX_WD%" F F snNum wNum
  %_@evalInt% !min: =@! "%_$MAX_WD%" F F snMin wMin
  %_@evalInt% !max: =@! "%_$MAX_WD%" F F snMax wMax  
  %_@compInts% "%snMin%" "%snMax%" "%wMin%" "%wMax%" comp
  %_@evalRange% "%comp%"
  %_@compInts% "%snNum%" "%snMin%" "%wNum%" "%wMin%" comp
  %_@evalRangeMin% "%comp%" rval
  %_@compInts% "%snNum%" "%snMax%" "%wNum%" "%wMax%" comp
  %_@evalRangeMax% "%comp%" rval
  exit /b 0
  
:_#rangef
   set "num=%1" & set "min=%2" & set "max=%3" & set "var=%4"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %5
  %_@evalFlt% !num: =@! "%_$MAX_WD%" snNum wNum dNum
  %_@evalFlt% !min: =@! "%_$MAX_WD%" snMin wMin dMin
  %_@evalFlt% !max: =@! "%_$MAX_WD%" snMax wMax dMax
  %_@compFlts% "%snMin%" "%snMax%" "%wMin%" "%dMin%" "%wMax%" "%dMax%" comp
  %_@evalRange% "%comp%"
  %_@compFlts% "%snNum%" "%snMin%" "%wNum%" "%dNum%" "%wMin%" "%dMin%" comp
  %_@evalRangeMin% "%comp%" rval
  %_@compFlts% "%snNum%" "%snMax%" "%wNum%" "%dNum%" "%wMax%" "%dMax%" comp
  %_@evalRangeMax% "%comp%" rval
  exit /b 0

:_#evali
  set "num=%1" & set "var=%2"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %3
  set "rval=FALSE" & set "_$show_errors="
  %_@evalInt% !num: =@! "%_$MAX_WD%" F F snNum wNum
  set "rval=TRUE"
  exit /b 0

:_#evalf
  set "num=%1" & set "var=%2"
  %_@evalRsltVar% !var: =@! rvar
  %_@evalStrayArg% %3
  set "rval=FALSE" & set "_$show_errors="
  %_@evalFlt% !num: =@! "%_$MAX_WD%" snNum wNum dNum
  set "rval=TRUE"
  exit /b 0

:_#setDeciPlaces
  set "places=%1"
  %_@evalStrayArg% %2
  %_@evalValue% !places: =@! "%_$MAX_DD%"
  set "rval=%~1" & set "rvar=_$dp"
  exit /b 0

:_#setRoundPos
  set "pos=%1"
  %_@evalStrayArg% %2
  %_@evalValue% !pos: =@! "%_$MAX_DD%"
  set "rval=%~1" & set "rvar=_$rd"
  exit /b 0

:_#setDeciMarkToPeriod
  %_@evalStrayArg% %1
  set "rval=." & set "rvar=_$dm"
  exit /b 0

:_#setDeciMarkToComma
  %_@evalStrayArg% %1
  set "rval=," & set "rvar=_$dm"
  exit /b 0

:_#enableErrorMes
  %_@evalStrayArg% %1
  set "rval=E" & set "rvar=_$show_errors"
  exit /b 0

:_#disableErrorMes
  %_@evalStrayArg% %1
  set "rval=" & set "rvar=_$show_errors"
  exit /b 0

:_#enableResultMes
  %_@evalStrayArg% %1
  set "rval=E" & set "rvar=_$show_results"
  exit /b 0

:_#disableResultMes
  %_@evalStrayArg% %1
  set "rval=" & set "rvar=_$show_results"
  exit /b 0

:_#enablePauseOnErrors
  %_@evalStrayArg% %1
  set "rval=E" & set "rvar=_$pause_on_errors"
  exit /b 0

:_#disablePauseOnErrors
  %_@evalStrayArg% %1
  set "rval=" & set "rvar=_$pause_on_errors"
  exit /b 0

::---------------- END LOCAL FUNCTION DEFINITIONS -----------------
::=================================================================

::=====================================================
::---------------- BEGIN INTRODUCTION -----------------

:_#intro
echo  ------------------------------------------------------------------------------
echo.
echo  arithmetic.bat v1.1
echo  Author: Ronnie Fernandez
echo  Email: RonDeCoder@tutamail.com
echo.
echo  v1.0 (2018-1-12)
echo  * Initial release.
echo  v1.1 (2018-1-24)
echo  * Fixed bug where user macros can't be called after changing directory.
echo  * Fixed other minor bugs and made some tweaks.
echo  * Added four new user macros @enableResultMes, @disableResultMes, 
echo    @enablePauseOnErrors and @disablePauseOnErrors.
echo.
echo  This script was created to overcome the limitations of arithmetic operations
echo  in the batch script language without the use of VBscript. It will allow for
echo  floating-point operations and integer operations beyond the 32-bit limit
echo  (even on 32-bit machines). It also evaluates any input passed in, includes
echo  functions to compare these extended numbers, and more.
echo.
echo  Because of the obvious overhead in doing all of this in script, macros are
echo  used extensively to help speed up operations. A big thanks to Ed Dyreen, Jeb,
echo  Dave Benham, and the others for coming up with the techniques.
echo.
echo  To use this script, simply call this file by inserting the line
echo  "call arithmetic.bat init" at the beginning of your batch file (before setting
echo  delayed expansion) or type "arithmetic init" if using from CMD. You will then
echo  be able to utilize all of the following user macros from then on.
echo.
echo  ---------- USER MACROS ----------
echo.
echo  @addi - Integer addition
echo  arg1: [addend(int:17 digits max)]
echo  arg2: [addend(int:17 digits max)]
echo  arg3: {result(int)}
echo.
echo  @subi - Integer subtraction
echo  arg1: [minuend(int:17 digits max)]
echo  arg2: [subtrahend(int:17 digits max)]
echo  arg3: {result(int)}
echo.
echo  @multi - Integer multiplication
echo  arg1: [multiplicand(int:16 digits max)]
echo  arg2: [multiplier(int:16 digits max)]
echo  arg3: {result(int)}
echo.
echo  @divi - Integer division
echo  arg1: [dividend(int:32 digits max)]
echo  arg2: [divisor(int:8 digits max)]
echo  arg3: {result(int)}
echo.
echo  @addf - Float addition
echo  arg1: [addend(float:W-9 digits max, D-16 digits max *8 before rounding)]
echo  arg2: [addend(float:W-9 digits max, D-16 digits max *8 before rounding)]
echo  arg3: {result(float)}
echo.
echo  @subf - Float subtraction
echo  arg1: [minuend(float:W-9 digits max, D-16 digits max *8 before rounding)]
echo  arg2: [subtrahend(float:W-9 digits max, D-16 digits max *8 before rounding)]
echo  arg3: {result(float)}
echo.
echo  @multf - Float multiplication
echo  arg1: [multiplicand(float:W-8 digits max, D-16 digits max *8 before rounding)]
echo  arg2: [multiplier(float:W-8 digits max, D-16 digits max *8 before rounding)]
echo  arg3: {result(float)}
echo.
echo  @divf - Float division
echo  arg1: [dividend(float:W-24 digits max, D-16 digits max *8 before rounding)]
echo  arg2: [divisor(float:8 digits max *combined)]
echo  arg3: {result(float)}
echo.
echo  @modi - Modulo for integers
echo  arg1: [dividend(int:16 digits max)]
echo  arg2: [divisor(int:8 digits max)]
echo  arg3: {result(int)}
echo.
echo  @modf - Modulo for floats
echo  arg1: [dividend(float:W-4 digits max, D-16 digits max *8 before rounding)]
echo  arg2: [divisor(float:8 digits max *combined, *D-5 digits before rounding)]
echo  arg3: {result(float)}
echo.
echo  @rand - Generates a random integer from 0 to 9999999
echo  arg1: {result(uint)}
echo.
echo  @randr - Generates a random integer within a specified range (can be negative)
echo  arg1: [min(int:7 digits max)]
echo  arg2: [max(int:7 digits max)]
echo  arg3: {result(int)}
echo.
echo  @trimf - Trims the decimals of a float by retaining only a specified amount
echo  arg1: [num(float:W-32 digits max, D-16 digits max)]
echo  arg2: [places(uint:0-15 *0=Discard all decimals)]
echo  arg3: {result(float)}
echo.
echo  @roundf - Rounds a float at a specified decimal position
echo  arg1: [num(float:W-32 digits max, D-16 digits max)]
echo  arg2: [pos(uint:0-15 *0=Round to nearest integer)]
echo  arg3: {result(float)}
echo.
echo  @compi - Integer comparison
echo  arg1: [numA(int:32 digits max)]
echo  arg2: [operator(op:EQU,NEQ,LEQ,GEQ,LSS,GTR)]
echo  arg3: [numB(int:32 digits max)]
echo  arg4: {result(BOOL:TRUE,FALSE)}
echo.
echo  @compf - Float comparison
echo  arg1: [numA(float:W-32 digits max, D-16 digits max)]
echo  arg2: [operator(op:EQU,NEQ,LEQ,GEQ,LSS,GTR)]
echo  arg3: [numB(float:W-32 digits max, D-16 digits max)]
echo  arg4: {result(BOOL:TRUE,FALSE)}
echo.
echo  @rangei - Verifies whether an integer is within a specified range
echo  arg1: [num(int:32 digits max)]
echo  arg2: [min(int:32 digits max)]
echo  arg3: [max(int:32 digits max)]
echo  arg4: {result(BOOL:TRUE,FALSE)}
echo.
echo  @rangef - Verifies whether a float is within a specified range
echo  arg1: [num(float:W-32 digits max, D-16 digits max)]
echo  arg2: [min(float:W-32 digits max, D-16 digits max)]
echo  arg3: [max(float:W-32 digits max, D-16 digits max)]
echo  arg4: {result(BOOL:TRUE,FALSE)}
echo.
echo  @evali - Verifies whether a number is a valid integer 
echo  arg1: [num(int:32 digits max)]
echo  arg2: {result(BOOL:TRUE,FALSE)}
echo.
echo  @evalf - Verifies whether a number is a valid float/integer
echo  arg1: [num(float:W-32 digits max, D-16 digits max))]
echo  arg2: {result(BOOL:TRUE,FALSE)}
echo.
echo  @setDeciPlaces - Sets the amount of decimal places to retain in float outputs
echo  arg1: [places(uint:0-16 *0=Discard all decimals, *16=Retain all decimals)]
echo.
echo  @setRoundPos - Sets the decimal position for the rounding of float outputs
echo  arg1: [pos(uint:0-16 *0=Round to nearest integer, *16=No rounding)]
echo.
echo  @setDeciMarkToPeriod - Sets the decimal mark to a period
echo.
echo  @setDeciMarkToComma - Sets the decimal mark to a comma
echo.
echo  @enableErrorMes - Enables internal error messages
echo.
echo  @disableErrorMes - Disables internal error messages
echo.
echo  @enableResultMes - Enables echoing of results
echo.
echo  @disableResultMes - Disables echoing of results
echo.
echo  @enablePauseOnErrors - Enables pause on errors
echo.
echo  @disablePauseOnErrors - Disables pause on errors
echo.
echo  ------------------------------------------------------------------------------
pause
exit /b 0

::---------------- END INTRODUCTION -----------------
::===================================================

::=======================================================
::---------------- BEGIN INITIALIZATION -----------------
:: This part will load all the variables and macros. This will only happen once.

:_#init

:: Exit if already initialized
if "%_$init_arithmetic%"=="TRUE" exit /b 0

:: Exit if delayed expansion is currently enabled.
if "!expansion!"=="" (
  echo ERROR {i}:
  echo Delayed expansion cannot be enabled before initialization.
  exit /b 1
)

::==================================================================
::---------------- BEGIN LOCAL VARIABLE DEFINITIONS ----------------
:: The following variables are for internal usage and should never be overridden.

:: Signal completion of initialization
set "_$init_arithmetic=TRUE"

set ^"LF=^
%= This creates a variable containing a single linefeed (0x0A) character =%
^"
:: Define %\n% to effectively issue a newline with line continuation
set ^"\n=^^^%LF%%LF%^%LF%%LF%^^"

:: Store repetitious lines for the beginning and ending parts of a macro
set "_$BEGIN_MACRO=for %%. in (1 2) do if %%.==2 ( for /f "tokens=1-9 eol= " %%1 in ("!argv!") do ("
set "_$END_MACRO=) ) else set argv="

:: Define evaluation error codes
set "_$EEC_ICOMM=1"
set "_$EEC_IRSLT=2"
set "_$EEC_TMA=3"
set "_$EEC_EMPTY=4"
set "_$EEC_ICHAR=5"
set "_$EEC_INFMT=6"
set "_$EEC_EMDIGTS=7"
set "_$EEC_EMVAL=8"
set "_$EEC_ZDSOR=9"
set "_$EEC_MINGMAX=10"
set "_$EEC_IOP=11"

:: Define max values
set "_$MAX_WHOLE=99999999999999999999999999999999"
set "_$MAX_ZEROS=0000000000000000000000000000000"
set "_$MAX_WD=32"
set "_$MAX_DD=16"
set "_$MAX_RP=15"

:: Set the default number of decimal places
set "_$dp=%_$MAX_DD%"

:: Set the default position for rounding decimals
set "_$rd=%_$MAX_DD%"

:: Set the default decimal mark
set "_$dm=."

:: Enables error messages
set "_$show_errors=E"

:: Enables the echoing of results
set "_$show_results=E"

:: Enables a pause on errors
set "_$pause_on_errors=E"

::---------------- END LOCAL VARIABLE DEFINITIONS ----------------
::================================================================

::==============================================================
::---------------- BEGIN USER MACRO DEFINITIONS ----------------
:: These are the only macros intended to be utilized by the user and
:: should never be overridden.

set @addi=call "%~f0" :_#addi,
set @subi=call "%~f0" :_#subi,
set @multi=call "%~f0" :_#multi,
set @divi=call "%~f0" :_#divi,
set @addf=call "%~f0" :_#addf,
set @subf=call "%~f0" :_#subf,
set @multf=call "%~f0" :_#multf,
set @divf=call "%~f0" :_#divf,
set @modi=call "%~f0" :_#modi,
set @modf=call "%~f0" :_#modf,
set @rand=call "%~f0" :_#rand,
set @randr=call "%~f0" :_#randr,
set @trimf=call "%~f0" :_#trimf,
set @roundf=call "%~f0" :_#roundf,
set @compi=call "%~f0" :_#compi,
set @compf=call "%~f0" :_#compf,
set @rangei=call "%~f0" :_#rangei,
set @rangef=call "%~f0" :_#rangef,
set @evali=call "%~f0" :_#evali,
set @evalf=call "%~f0" :_#evalf,
set @setDeciPlaces=call "%~f0" :_#setDeciPlaces,
set @setRoundPos=call "%~f0" :_#setRoundPos,
set @setDeciMarkToPeriod=call "%~f0" :_#setDeciMarkToPeriod,
set @setDeciMarkToComma=call "%~f0" :_#setDeciMarkToComma,
set @enableErrorMes=call "%~f0" :_#enableErrorMes,
set @disableErrorMes=call "%~f0" :_#disableErrorMes,
set @enableResultMes=call "%~f0" :_#enableResultMes,
set @disableResultMes=call "%~f0" :_#disableResultMes,
set @enablePauseOnErrors=call "%~f0" :_#enablePauseOnErrors,
set @disablePauseOnErrors=call "%~f0" :_#disablePauseOnErrors,

::---------------- END USER MACRO DEFINITIONS ----------------
::============================================================

::===============================================================
::---------------- BEGIN LOCAL MACRO DEFINITIONS ----------------
:: These are only for internal usage and should never be overridden.

:: {sign(char:-,) %1}
set _@negateSign=%_$BEGIN_MACRO% %\n%
  if "!%%~1!"=="-" (set "%%~1=") else (set "%%~1=-") %\n%
%_$END_MACRO%

:: [num(uint) %1] {len(uint) %2}
set _@intLen=%_$BEGIN_MACRO% %\n%
  set "n=%%~1" ^& set "%%~2=1" %\n%
  if "!n:~0,1!"=="0" set "n=!n:~1!" %\n%
  for %%P in (32 16 8 4 2 1) do if not "!n:~%%P,1!"=="" (set /a "%%~2+=%%P" ^& set "n=!n:~%%P!") %\n%
%_$END_MACRO%

:: [num(uint) %1] {len(uint) %2}
set _@fltLen=%_$BEGIN_MACRO% %\n%
  set "n=%%~1" ^& set "%%~2=1" %\n%
  for %%P in (16 8 4 2 1) do if not "!n:~%%P,1!"=="" (set /a "%%~2+=%%P" ^& set "n=!n:~%%P!") %\n%
%_$END_MACRO%

:: {[bnum(uint) %1]}
set _@fmtInt=%_$BEGIN_MACRO% %\n%
  set "%%~1=0000000!%%~1!" ^& set "%%~1=!%%~1:~-8!" %\n%
%_$END_MACRO%

:: {[deci(uint) %1]}
set _@fmtDeci=%_$BEGIN_MACRO% %\n%
  set "%%~1=!%%~1!00000000" ^& set "%%~1=!%%~1:~0,8!" %\n%
%_$END_MACRO%

:: [num(uint) %1] [fmtBack(bool:T,F) %2] {fNum(uint) %3} {bNum(uint) %4}
set _@splitUInt=%_$BEGIN_MACRO% %\n%
  set "n=%%~1" %\n%
  if "!n:~8,1!"=="" ( %\n%
	set "%%~3=0" %\n%
	if "%%~2"=="T" (set "%%~4=0000000!n!" ^& set "%%~4=!%%~4:~-8!") else (set "%%~4=!n!") %\n%
  ) else set "%%~3=!n:~0,-8!" ^& set "%%~4=!n:~-8!" %\n%
%_$END_MACRO%

:: [strayArg(*) %1]
set _@evalStrayArg=%_$BEGIN_MACRO% %\n%
  if not "%%1"=="" set "_$ed=%%1" ^& exit /b %_$EEC_TMA% %\n%
%_$END_MACRO%

:: [inRsltVar(string) %1] {outRsltVar(string) %2}
set _@evalRsltVar=%_$BEGIN_MACRO% %\n%
  if not "%%~1"=="" if not "%%~1"=="=@" ( %\n%
	set "rv=%%~1" %\n%
	if not "!rv!"=="!rv:@=!" set "_$ed=%%~1" ^& exit /b %_$EEC_IRSLT% %\n%
	if "!rv:~0,2!"=="_$" set "_$ed=%%~1" ^& exit /b %_$EEC_IRSLT% %\n%
	set "%%~2=!rv!" %\n%
  ) %\n%
%_$END_MACRO%

:: [value(uint) %1] [max(uint) %2]
set _@evalValue=%_$BEGIN_MACRO% %\n%
  set "n=%%~1" %\n%
  if "!n!"=="" set "_$ed={UNSIGNED INT VALUE}" ^& exit /b %_$EEC_EMPTY% %\n%
  if "!n!"=="=@" set "_$ed={UNSIGNED INT VALUE}" ^& exit /b %_$EEC_EMPTY% %\n%
  for /f "eol= delims=0123456789" %%A in ("!n!") do set "_$ed=%%~1" ^& exit /b %_$EEC_ICHAR% %\n%
  if "!n:~0,1!"=="0" if not "!n:~1,1!"=="" set "_$ed={LEAD ZEROS IN WHOLE} %%~1" ^& exit /b %_$EEC_INFMT% %\n%
  if %%~1 gtr %%~2 set "_$ed={MAX=%%~2} %%~1" ^& exit /b %_$EEC_EMVAL% %\n%
%_$END_MACRO%

:: [num(int) %1] [fMax(uint) %2] [split(bool:T,F) %3] [fmtBack(bool:T,F) %4]
:: {sign(char:-,) %5} {fNum(uint) %6} {bNum(uint) %7}
set _@evalInt=%_$BEGIN_MACRO% %\n%
  set "n=%%~1" %\n%
  if "!n!"=="" set "_$ed={INT VALUE}" ^& exit /b %_$EEC_EMPTY% %\n%
  if "!n!"=="=@" set "_$ed={INT VALUE}" ^& exit /b %_$EEC_EMPTY% %\n%
  if "!n:~0,1!"=="-" (set "%%~5=-" ^& set "n=!n:~1!") else (set "%%~5=") %\n%
  if "!n!"=="" set "_$ed={MISSING NUMBER} %%~1" ^& exit /b %_$EEC_INFMT% %\n%
  for /f "eol= delims=0123456789" %%A in ("!n!") do set "_$ed=%%~1" ^& exit /b %_$EEC_ICHAR% %\n%
  if "!n:~0,1!"=="0" if not "!n:~1,1!"=="" set "_$ed={LEAD ZEROS IN WHOLE} %%~1" ^& exit /b %_$EEC_INFMT% %\n%
  if "%%~3"=="F" ( %\n%
	set "%%~6=!n!" %\n%
	if not "!%%~6:~%%~2,1!"=="" set "_$ed={%%~2 DIGITS MAX} %%~1" ^& exit /b %_$EEC_EMDIGTS% %\n%
  ) else if not "!n:~8,1!"=="" ( %\n%
	set "%%~6=!n:~0,-8!" ^& set "%%~7=!n:~-8!" %\n%
	if not "!%%~6:~%%~2,1!"=="" set /a "m=%%~2+8" ^& set "_$ed={!m! DIGITS MAX} %%~1" ^& exit /b %_$EEC_EMDIGTS% %\n%
  ) else ( %\n%
	set "%%~6=0" %\n%
	if "%%~4"=="T" (set "%%~7=0000000!n!" ^& set "%%~7=!%%~7:~-8!") else (set "%%~7=!n!") %\n%
  ) %\n%
%_$END_MACRO%

:: [num(float) %1] [wMax(uint) %2] {sign(char:-,) %3} {whole(uint) %4} {deci(uint) %5}
set _@evalFlt=%_$BEGIN_MACRO% %\n%
  set "n=%%~1" ^& set "dp=" ^& set "w=" %\n%
  if "!n!"=="" set "_$ed={FLOAT VALUE}" ^& exit /b %_$EEC_EMPTY% %\n%
  if "!n!"=="=@" set "_$ed={FLOAT VALUE}" ^& exit /b %_$EEC_EMPTY% %\n%
  if "!n:~0,1!"=="-" (set "%%~3=-" ^& set "n=!n:~1!") else (set "%%~3=") %\n%
  if "!n!"=="" set "_$ed={MISSING NUMBER} %%~1" ^& exit /b %_$EEC_INFMT% %\n%
  for /f "tokens=1-2 eol= delims=0123456789" %%A in ("!n!") do set "dp=%%A%%B" %\n%
  if defined dp ( %\n%
	if not "!dp!"=="." if not "!dp!"=="," set "_$ed=%%~1" ^& exit /b %_$EEC_ICHAR% %\n%
	for %%P in ("." ",") do if "!n:~0,1!"=="%%~P!" (set "w=0" ^& set "d=!n:~1!") %\n%
	if "!w!"=="" for /f "tokens=1-2 delims=.," %%A in ("!n!") do (set "w=%%A" ^& set "d=%%B") %\n%
    set "%%~4=!w!" %\n%
	if "!d!"=="" set "_$ed={MISSING DECIMAL VALUE} %%~1" ^& exit /b %_$EEC_INFMT% %\n%
    if not "!d:~%_$MAX_DD%,1!"=="" set "_$ed={%_$MAX_DD% DECIMAL DIGITS MAX} %%~1" ^& exit /b %_$EEC_EMDIGTS% %\n%
	if !d! equ 0 (set "%%~5=0") else (set "%%~5=!d!") %\n%
  ) else set "%%~4=!n!" ^& set "%%~5=0" %\n%
  if "!%%~4:~0,1!"=="0" if not "!%%~4:~1,1!"=="" set "_$ed={LEAD ZEROS IN WHOLE} %%~1" ^& exit /b %_$EEC_INFMT% %\n%
  if not "!%%~4:~%%~2!"=="" set "_$ed={%%~2 WHOLE DIGITS MAX} %%~1" ^& exit /b %_$EEC_EMDIGTS% %\n%
%_$END_MACRO%

:: [fDsor(uint) %1] [bDsor(uint) %2]
set _@evalFltDsor=%_$BEGIN_MACRO% %\n%
  set "len=1" %\n%
  if %%~1%%~2 equ 0 exit /b %_$EEC_ZDSOR% %\n%
  if %%~1 equ 0 (set "n=%%~2") else if %%~2 equ 0 (set "n=%%~1") else (set "n=%%~1%%~2") %\n%
  for %%P in (8 4 2 1) do if not "!n:~%%P,1!"=="" (set /a "len+=%%P" ^& set "n=!n:~%%P!") %\n%
  if !len! gtr 8 set "_$ed={8 DIGITS MAX COMBINED} %%~1.%%~2" ^& exit /b %_$EEC_EMDIGTS% %\n%
%_$END_MACRO%

:: [dsor(uint) %1]
set _@evalIntDsor=%_$BEGIN_MACRO% %\n%
  if %%~1 equ 0 exit /b %_$EEC_ZDSOR% %\n%
%_$END_MACRO%

::comp(char:G,L,E) %1]
set _@evalRange=%_$BEGIN_MACRO% %\n%
  if "%%~1"=="G" exit /b %_$EEC_MINGMAX% %\n%
%_$END_MACRO%

::comp(char:G,L,E) %1] {result(BOOL:FALSE) %2}
set _@evalRangeMin=%_$BEGIN_MACRO% %\n%
  if "%%~1"=="L" set "%%~2=FALSE" ^& exit /b 0 %\n%
%_$END_MACRO%

::comp(char:G,L,E) %1] {result(BOOL:TRUE,FALSE) %2}
set _@evalRangeMax=%_$BEGIN_MACRO% %\n%
  if not "%%~1"=="G" (set "%%~2=TRUE") else (set "%%~2=FALSE") %\n%
%_$END_MACRO%

:: [operator(op:EQU,NEQ,LEQ,GEQ,LSS,GTR) %1] [comp(char:G,L,E) %2] {result(BOOL:TRUE,FALSE) %3}
set _@evalOp=%_$BEGIN_MACRO% %\n%
  if "%%~1"=="" set "_$ed={COMPARE OPERATOR}" ^& exit /b %_$EEC_EMPTY% %\n%
  if "%%~1"=="=@" set "_$ed={COMPARE OPERATOR}" ^& exit /b %_$EEC_EMPTY% %\n%
  if /I "%%~1"=="EQU" ( %\n%
	if not "%%~2"=="E" (set "%%~3=FALSE") else (set "%%~3=TRUE") %\n%
  ) else if /I "%%~1"=="NEQ" ( %\n%
	if "%%~2"=="E" (set "%%~3=FALSE") else (set "%%~3=TRUE") %\n%
  ) else if /I "%%~1"=="LEQ" ( %\n%
	if "%%~2"=="G" (set "%%~3=FALSE") else (set "%%~3=TRUE") %\n%
  ) else if /I "%%~1"=="GEQ" ( %\n%
	if "%%~2"=="L" (set "%%~3=FALSE") else (set "%%~3=TRUE") %\n%
  ) else if /I "%%~1"=="LSS" ( %\n%
	if not "%%~2"=="L" (set "%%~3=FALSE") else (set "%%~3=TRUE") %\n%
  ) else if /I "%%~1"=="GTR" ( %\n%
	if not "%%~2"=="G" (set "%%~3=FALSE") else (set "%%~3=TRUE") %\n%
  ) else set "_$ed={OPERATORS=EQU,NEQ,LEQ,GEQ,LSS,GTR} %%~1" ^& exit /b %_$EEC_IOP% %\n%
%_$END_MACRO%

:: [sign(char:-,) %1] [num(uint) %2] {result(int) %3}
set _@finIntAS=%_$BEGIN_MACRO% %\n%
  if %%~2 equ 0 (set "%%~3=0") else (set "%%~3=%%~1%%~2") %\n%
%_$END_MACRO%

:: [signA(char:-,) %1] [signB(char:-,) %2] [num(uint) %3] {result(int) %4}
set _@finIntMD=%_$BEGIN_MACRO% %\n%
  if %%~3 equ 0 (set "%%~4=0") else if "%%~1"=="%%~2" (set "%%~4=%%~3") else (set "%%~4=-%%~3") %\n%
%_$END_MACRO%

:: [sign(char:-,) %1] [whole(uint) %2] [deci(uint) %3] [dMark(char:,.) %4] {result(float) %5}
set _@finFltAS=%_$BEGIN_MACRO% %\n%
  if %%~2%%~3 equ 0 (set "sn=") else (set "sn=%%~1") %\n%
  if not "%%~3"=="" (set "%%~5=!sn!%%~2%%~4%%~3") else (set "%%~5=!sn!%%~2") %\n%
%_$END_MACRO%

:: [signA(char:-,) %1] [signB(char:-,) %2] [whole(uint) %3] [deci(uint) %4] [dMark(char:,.) %5]
:: {result(float) %6}
set _@finFltMD=%_$BEGIN_MACRO% %\n%
  if %%~3%%~4 equ 0 (set "sn=") else if "%%~1"=="%%~2" (set "sn=") else (set "sn=-") %\n%
  if not "%%~4"=="" (set "%%~6=!sn!%%~3%%~5%%~4") else (set "%%~6=!sn!%%~3") %\n%
%_$END_MACRO%

:: [sign(char:-,) %1] [num(uint) %2] [min(uint) %3] {result(int) %4}
set _@finRand=%_$BEGIN_MACRO% %\n%
  set /a "%%~4=%%~2+%%~3" %\n%
  if !%%~4! neq 0 set "%%~4=%%~1!%%~4!" %\n%
%_$END_MACRO%

:: [signA(char:,-) %1] [signB(char:,-) %2] [fAendA(uint) %3] [bAendA(uint) %4] [fAendB(uint) %5]
:: [bAendB(uint) %6] {sumSign(char:,-) %7} {fSum(int) %8} {bSum(uint) %9}
set _@add=%_$BEGIN_MACRO% %\n%
  if "%%~1"=="%%~2" ( %\n%
	set /a "f=%%~3+%%~5" ^& set /a "b=1%%~4+1%%~6" %\n%
    if "!b:~0,1!"=="3" set /a "f+=1" %\n%
	set "%%~8=!f!" ^& set "%%~9=!b:~1!" ^& set "%%~7=%%~1" %\n%
  ) else ( %\n%
    set "%%~7=" ^& set /a "f=%%~1%%~3+%%~2%%~5" ^& set /a "b=%%~11%%~4+%%~21%%~6" %\n%
	if !b! gtr 0 ( %\n%
	  if !f! lss 0 ( %\n%
	    set /a "f+=1" ^& set /a "b=200000000-!b!" ^& set "%%~7=-" %\n%
		if !f! lss 0 set "f=!f:~1!" %\n%
	  ) else set "b=0000000!b!" %\n%
	) else if !b! lss 0 ( %\n%
	  if !f! gtr 0 ( %\n%
	    set /a "f-=1" ^& set /a "b=200000000+!b!" %\n%
	  ) else ( %\n%
		set "b=0000000!b:~1!" ^& set "%%~7=-" %\n%
		if !f! lss 0 set "f=!f:~1!" %\n%
	  ) %\n%
	) else set "b=00000000" %\n%
	set "%%~8=!f!" ^& set "%%~9=!b:~-8!" %\n%
  ) %\n%
%_$END_MACRO%

:: [fMand(uint) %1] [bMand(uint) %2] [fMltr(uint) %3] [bMltr(uint) %4] [mandLen(uint) %5] 
:: [mltrLen(uint) %6] {fProd(uint) %7} {bProd(uint,) %8}
set _@multiply=%_$BEGIN_MACRO% %\n%
  set "pt=000000000" ^& set "bz=" %\n%
  if %%~5 geq %%~6 ( %\n%
	set "mr=%%~3%%~4" ^& set "mrlen=%%~6" ^& set "fmd=%%~1" ^& set "bmd=%%~2" ^& set "bmr=%%~4" %\n%
  ) else set "mr=%%~1%%~2" ^& set "mrlen=%%~5" ^& set "fmd=%%~3" ^& set "bmd=%%~4" ^& set "bmr=%%~2" %\n%
  if not "%%~8"=="" ( %\n%
	set "dp=9" %\n%
    for %%P in (8 4 2 1) do if not "!bmr:~%%P,1!"=="" (set /a "dp+=%%P" ^& set "bmr=!bmr:~%%P!") %\n%
	set "bmd=!bmd!0000000" ^& set "bmd=!bmd:~0,8!" %\n%
  ) else set "bmd=0000000!bmd!" ^& set "bmd=!bmd:~-8!" ^& set "dp=" %\n%
  if !bmd! neq 0 ( %\n%
	if "!bmd:~0,1!"=="0" ( %\n%
	  for /f "delims=123456789" %%A in ("!bmd!") do set "bz=%%A" %\n%
      for /f "tokens=* delims=0" %%A in ("!bmd!") do set "bmd=%%A" %\n%
	) %\n%
  ) else set "bz=0000000" ^& set "bmand=0" %\n%
  for /l %%G in (1,1,!mrlen!) do ( %\n%
    set "mp=!mr:~-%%G,1!" %\n%
	if !mp! neq 0 ( %\n%
	  set /a "bA=!bmd!*!mp!" ^& set "bA=!bz!!bA!" %\n%
      if !fmd! equ 0 ( %\n%
	    if not "!bA:~8,1!"=="" ( %\n%
	      set "fA=!bA:~0,1!" ^& set "bA=!bA:~1!" %\n%
		) else set "fA=0" %\n%
      ) else if not "!bA:~8,1!"=="" ( %\n%
	    set /a "fA=(!fmd!*!mp!)+!bA:~0,1!" ^& set "bA=!bA:~1!" %\n%
      ) else set /a "fA=!fmd!*!mp!" %\n%
	  set "fcut=!pt:~0,-%%G!" %\n%
      if !fcut! neq 0 ( %\n%
		if not "!fcut:~8,1!"=="" ( %\n%
		  set "fB=!fcut:~0,-8!" ^& set "bB=!fcut:~-8!" %\n%
		  if "!fB:~0,1!"=="0" ( %\n%
			for /f "tokens=* delims=0" %%A in ("!fB!") do set "fB=%%A" %\n%
		    if "!fB!"=="" set "fB=0" %\n%
		  ) %\n%
	    ) else set "fB=0" ^& set "bB=0000000!fcut!" ^& set "bB=!bB:~-8!" %\n%
		set /a "f=!fA!+!fB!" ^& set /a "b=1!bA!+1!bB!" %\n%
        if "!b:~0,1!"=="3" set /a "f+=1" %\n%
        set "pt=!f!!b:~1!!pt:~-%%G!" %\n%
	  ) else set "pt=!fA!!bA!!pt:~-%%G!" %\n%
    ) else set "pt=0!pt!" %\n%
  ) %\n%
  if defined dp ( %\n%
	set "pt=!pt:~0,-1!" %\n%
	for %%G in (!dp!) do set "%%~7=!pt:~0,-%%G!" ^& set "%%~8=!pt:~-%%G!" %\n%
  ) else set "%%~7=!pt:~0,-1!" %\n%
%_$END_MACRO%

:: [dend(uint) %1] [dsor(uint) %2] [dendLen(uint) %3] {quotient(uint) %4}
set _@divideInts=%_$BEGIN_MACRO% %\n%
  set "seg=0" ^& set "%%~4=" ^& set "dd=%%~1" ^& set /a "ilen=%%~3-1" %\n%
  for /l %%G in (0,1,!ilen!) do (	%\n%
    if %%~2 gtr !seg! ( %\n%
	  if !seg! equ 0 set "seg=" %\n%
	  set "seg=!seg!!dd:~%%G,1!" %\n%
	) %\n%
	if %%~2 leq !seg! ( %\n%
	  set /a "qtd=!seg!/%%~2" ^& set /a "seg=!seg!-(!qtd!*%%~2)" ^& set "%%~4=!%%~4!!qtd!" %\n%
	) else if !%%~4! neq 0 set "%%~4=!%%~4!0" %\n%
  ) %\n%
  if "!%%~4!"=="" set "%%~4=0" %\n%
%_$END_MACRO%

:: [fDend(uint) %1] [bDend(uint) %2] [fDsor(uint) %3] [bDsor(uint) %4] [dendLen(uint) %5]
:: [dsorLen(uint) %6] [dPlaces(uint) %7] {fQuo(uint) %8} {bQuo(uint) %9}
set _@divideFlts=%_$BEGIN_MACRO% %\n%
  set "seg=0" ^& set "bdr=%%~4" %\n%
  if !bdr! gtr 0 ( %\n%
	set "n=!bdr!" ^& set "dlen=1" %\n%
	for %%P in (8 4 2 1) do if not "!n:~%%P,1!"=="" (set /a "dlen+=%%P" ^& set "n=!n:~%%P!") %\n%
  ) else set "dlen=0" %\n%
  if %%~3 neq 0 ( %\n%
    if !bdr! neq 0 (set "dr=%%~3!bdr!") else (set "dr=%%~3") %\n%
  ) else for /f "tokens=* delims=0" %%A in ("!bdr!") do set "dr=%%A" %\n%
  set /a "az=%%~7+!dlen!" ^& set /a "ilen=!az!+%%~5-1" %\n%
  if %%~2 neq 0 (set /a "az+=!dlen!-%%~6") else (set "%%~2=") %\n%
  for %%G in (!az!) do set "dd=%%~1%%~2!_$MAX_ZEROS:~0,%%G!" %\n%
  for /l %%G in (0,1,!ilen!) do (	%\n%
	if !dr! gtr !seg! ( %\n%
	  if !seg! equ 0 set "seg=" %\n%
	  set "seg=!seg!!dd:~%%G,1!" %\n%
	) %\n%
	if !dr! leq !seg! ( %\n%
	  set /a "qtd=!seg!/!dr!" ^& set /a "seg=!seg!-(!qtd!*!dr!)" ^& set "qt=!qt!!qtd!" %\n%
	) else set "qt=!qt!0" %\n%
  ) %\n%
  if %%~7 gtr 0 (set "%%~8=!qt:~0,-%%~7!" ^& set "%%~9=!qt:~-%%~7!") else (set "%%~8=!qt!" ^& set "%%~9=") %\n%
%_$END_MACRO%

:: [signA(char:-,) %1] [signB(char:-,) %2] [numA(uint) %3] [numB(uint) %4] {comp(char:G,L,E) %5}
set _@compInts=%_$BEGIN_MACRO% %\n%
  if "%%~1"=="%%~2" ( %\n%
	set "wA=!_$MAX_ZEROS!%%~3" ^& set "nA=!wA:~-%_$MAX_WD%!" %\n%
	set "wB=!_$MAX_ZEROS!%%~4" ^& set "nB=!wB:~-%_$MAX_WD%!" %\n%
	if "!nA!" gtr "!nB!" ( %\n%
	  if "%%~1"=="-" (set "%%~5=L") else (set "%%~5=G") %\n%
	) else if "!nA!" lss "!nB!" ( %\n%
	  if "%%~1"=="-" (set "%%~5=G") else (set "%%~5=L") %\n%
	) else set "%%~5=E" %\n%
  ) else if %%~3%%~4 equ 0 ( %\n%
    set "%%~5=E" %\n%
  ) else if "%%~1"=="-" (set "%%~5=L") else (set "%%~5=G") %\n%
%_$END_MACRO%

:: [signA(char:-,) %1] [signB(char:-,) %2] [wholeA(uint) %3] [deciA(uint) %4]
:: [wholeB(uint) %5] [deciB(uint) %6] {comp(char:G,L,E) %7}
set _@compFlts=%_$BEGIN_MACRO% %\n%
  if "%%~1"=="%%~2" ( %\n%
	set "wA=!_$MAX_ZEROS!%%~3" ^& set "dA=%%~4!_$MAX_ZEROS!" ^& set "nA=!wA:~-%_$MAX_WD%!!dA:~0,%_$MAX_DD%!" %\n%
	set "wB=!_$MAX_ZEROS!%%~5" ^& set "dB=%%~6!_$MAX_ZEROS!" ^& set "nB=!wB:~-%_$MAX_WD%!!dB:~0,%_$MAX_DD%!" %\n%
	if "!nA!" gtr "!nB!" ( %\n%
	  if "%%~1"=="-" (set "%%~7=L") else (set "%%~7=G") %\n%
	) else if "!nA!" lss "!nB!" ( %\n%
	  if "%%~1"=="-" (set "%%~7=G") else (set "%%~7=L") %\n%
	) else set "%%~7=E" %\n%
  ) else if %%~3%%~4%%~5%%~6 equ 0 ( %\n%
    set "%%~7=E" %\n%
  ) else if "%%~1"=="-" (set "%%~7=L") else (set "%%~7=G") %\n%
%_$END_MACRO%

:: [num(uint) %1] {result(uint) %2}
set _@trimLeadZeros=%_$BEGIN_MACRO% %\n%
  for /f "tokens=* delims=0" %%P in ("%%~1") do set "%%~2=%%P" %\n%
  if "!%%~2!"=="" set "%%~2=0" %\n%
%_$END_MACRO%

:: [deci(uint) %1] [dPlaces(uint) %2] {result(uint) %3}
set _@trimDecimals=%_$BEGIN_MACRO% %\n%
  if %%~1 neq 0 ( %\n%
    if %%~2 neq 0 ( %\n%
	  set "n=%%~1" %\n%
	  set "n=!n:~0,%%~2!" ^& set "%%~3=!n!" ^& set "len=1" %\n%
	  for %%P in (8 4 2 1) do if !n:~%%P! neq 0 (set /a "len+=%%P" ^& set "n=!n:~%%P!") %\n%
	  for %%G in (!len!) do set "%%~3=!%%~3:~0,%%G!" %\n%
	  if !%%~3! equ 0 set "%%~3=" %\n%
    ) else set "%%~3=" %\n%
  ) else set "%%~3=" %\n%
%_$END_MACRO%

:: {result(uint) %1}
set _@genRand=%_$BEGIN_MACRO% %\n%
  set /a "%%~1=(!RANDOM! %% 3000)*(!RANDOM! %% 30000)" %\n%
%_$END_MACRO%

:: [minSign(char:-,) %1] [maxSign(char:-,) %2] [min(uint) %3] [max(uint) %4]
:: {finSign(char:-,) %5} {finMin(uint) %6} {mand(uint) %7} {mltr(uint) %8} 
set _@genRandRange=%_$BEGIN_MACRO% %\n%
  if %%~3 equ 0 (set "mn=%%~2") else (set "mn=%%~1") %\n%
  if %%~4 equ 0 (set "mx=%%~1") else (set "mx=%%~2") %\n%
  if not "!mn!"=="!mx!" ( %\n%
    set "%%~6=0" %\n%
	if %%~4 gtr %%~3 ( %\n%
	  set "a=!RANDOM!" ^& set /a "b=16384/(%%~4/%%~3)" %\n%
	) else set /a "a=16384/(%%~3/%%~4)" ^& set "b=!RANDOM!" %\n%
	if !a! gtr !b! ( %\n%
      set "%%~5=" ^& set /a "%%~8=%%~4+1" %\n%
	) else set "%%~5=-" ^& set /a "%%~8=%%~3+1" %\n%
  ) else ( %\n%
    set "%%~5=!mn!" %\n%
    if "!mn!"=="-" ( %\n%
	  set "%%~6=%%~4" ^& set /a "%%~8=%%~3-%%~4+1" %\n%
	) else set "%%~6=%%~3" ^& set /a "%%~8=%%~4-%%~3+1" %\n%
  ) %\n%
  set /a "%%~7=(!RANDOM! %% 3000)*(!RANDOM! %% 30000)" %\n%
%_$END_MACRO%

:: [whole(uint) %1] [deci(uint) %2] [rDigit(uint) %3] {wRslt(uint) %4} {dRslt(uint) %5}
set _@roundFlt=%_$BEGIN_MACRO% %\n%
  set "%%~4=%%~1" ^& set "%%~5=%%~2" ^& set "p=!%%~5:~%%~3,1!" %\n%
  if not "%%~2"=="" if not "!p!"=="" ( %\n%
    if !p! geq 5 ( %\n%
	  set /a "sp=%%~3-1" ^& set "done=" %\n%
	  for /l %%G in (!sp!,-1,0) do if not defined done ( %\n%
	    set /a "dgt=!%%~5:~%%G,1!+1" %\n%
	    if !dgt! lss 10 (set "%%~5=!%%~5:~0,%%G!!dgt!" ^& set "done=T") %\n%
	  ) %\n%
	  if not defined done ( %\n%
	    if not "!%%~4!"=="!_$MAX_WHOLE!" ( %\n%
	      set "%%~5=" ^& set "n=%%~1" ^& set "ws=0" ^& set "z=" %\n%
          for %%P in (16 8 4 2 1) do if not "!n:~%%P,1!"=="" (set /a "ws+=%%P" ^& set "n=!n:~%%P!") %\n%
	      for /l %%G in (!ws!,-1,0) do if not defined done ( %\n%
	        set /a "dgt=!%%~4:~%%G,1!+1" %\n%
		    if !dgt! lss 10 ( %\n%
		      set "%%~4=!%%~4:~0,%%G!!dgt!!z!" ^& set "done=T" %\n%
		    ) else set "z=0!z!" %\n%
		  ) %\n%
		  if not defined done for %%G in (!ws!) do set "%%~4=10!_$MAX_ZEROS:~0,%%G!" %\n%
		) %\n%
	  ) %\n%
	) else set "%%~5=!%%~5:~0,%%~3!" ^& if !%%~5! equ 0 (set "%%~5=") %\n%
  ) %\n%
%_$END_MACRO%

:: [errorcode(uint) %1]
set _@showErrorMes=%_$BEGIN_MACRO% %\n%
  if %%~1 gtr 0 ( %\n%
    echo ERROR {%%~1}: %\n%
    if %%~1 equ %_$EEC_ICOMM% ( %\n%
	  echo Invalid command. %\n%
    ) else if %%~1 equ %_$EEC_IRSLT% ( %\n%
	  echo The result argument cannot contain spaces, '@', or begin with '_$': %\n%
	) else if %%~1 equ %_$EEC_TMA% ( %\n%
	  echo Too many arguments specified: %\n%
    ) else if %%~1 equ %_$EEC_EMPTY% ( %\n%
	  echo A required argument was empty or missing: %\n%
    ) else if %%~1 equ %_$EEC_ICHAR% ( %\n%
      echo A numerical argument contained spaces or invalid characters: %\n%
    ) else if %%~1 equ %_$EEC_INFMT% ( %\n%
	  echo A numerical argument contained an invalid or incomplete number format: %\n%
    ) else if %%~1 equ %_$EEC_EMDIGTS% ( %\n%
	  echo A numerical argument exceeded the maximum number of digits: %\n%
	) else if %%~1 equ %_$EEC_EMVAL% ( %\n%
	  echo The value exceeded the maximum amount allowed: %\n%
    ) else if %%~1 equ %_$EEC_ZDSOR% ( %\n%
	  echo The divisor argument was zero. %\n%
	) else if %%~1 equ %_$EEC_MINGMAX% ( %\n%
	  echo The minimum value cannot be greater than the maximum value. %\n%
    ) else if %%~1 equ %_$EEC_IOP% ( %\n%
	  echo The compare operator argument was invalid: %\n%
	) else echo Unknown %\n%
	if defined _$ed echo !_$ed! %\n%
	if defined _$pause_on_errors pause %\n%
  ) %\n%
%_$END_MACRO%

::---------------- END LOCAL MACRO DEFINITIONS ----------------
::=============================================================

::---------------- END INITIALIZATION ----------------
::====================================================